
function _utf8_decode(utftext) {
		var string = "";
		var i = 0;
		var c = c1 = c2 = 0;
 
		while ( i < utftext.length ) {
 
			c = utftext.charCodeAt(i);
 
			if (c < 128) {
				string += String.fromCharCode(c);
				i++;
			}
			else if((c > 191) && (c < 224)) {
				c2 = utftext.charCodeAt(i+1);
				string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
				i += 2;
			}
			else {
				c2 = utftext.charCodeAt(i+1);
				c3 = utftext.charCodeAt(i+2);
				string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
				i += 3;
			}
 
		}
 
		return string;
}
	
jQuery.extend({
  parseQueryString: function(qs){
  	var nvpair = {};
    var qs =_utf8_decode(unescape(qs)).replace('?', '');
    $.each(qs.split('&'), function(i, v){
      var pair = v.split('=');
      nvpair[pair[0]] = pair[1];
    });
    return nvpair;
  }
});


(function($, undefined) {

    var kendo = window.kendo,

        extend = $.extend,

        odataFilters = {

            eq: "eq",

            neq: "ne",

            gt: "gt",

            gte: "ge",

            lt: "lt",

            lte: "le",

            contains : "substringof",

            endswith: "endswith",

            startswith: "startswith"

        },

        mappers = {
        	read: {
        	
        	$format: "json",

            $inlinecount: "allpages",

            pageSize: $.noop,

            page: $.noop,

            filter: function(params, filter) {

                if (filter) {

                    params.$filter = toOdataFilter(filter);

                }

            },

            sort: function(params, orderby) {

                params.$orderby = $.map(orderby, function(value) {

                    var order = value.field.replace(/\./g, "/");



                    if (value.dir === "desc") {

                        order += " desc";

                    }



                    return order;

                }).join(",");

            },

            skip: function(params, skip) {

                if (skip) {

                    params.$skip = skip;

                }

            },

            take: function(params, take) {

                if (take) {

                    params.$top = take;

                }

            }
            },
			update: { 
				$inlinecount: function() {}, 
				$format: function() {} 
			}
        },

        defaultDataType = {

            read: {

                dataType: "json"

            },
            
            update: {

                dataType: "json"

            }

        };



    function toOdataFilter(filter) {

        var result = [],

            logic = filter.logic || "and",

            idx,

            length,

            field,

            type,

            format,

            operator,

            value,

            filters = filter.filters;



        for (idx = 0, length = filters.length; idx < length; idx++) {

            filter = filters[idx];

            field = filter.field;

            value = filter.value;

            operator = filter.operator;



            if (filter.filters) {

                filter = toOdataFilter(filter);

            } else {

                field = field.replace(/\./g, "/"),



                filter = odataFilters[operator];



                if (filter && value !== undefined) {

                    type = $.type(value);

                    if (type === "string") {

                        format = "'{1}'";

                        value = value.replace(/'/g, "''");

                    } else if (type === "date") {

                        format = "datetime'{1:yyyy-MM-ddTHH:mm:ss}'";

                    } else {

                        format = "{1}";

                    }



                    if (filter.length > 3) {

                        if (filter !== "substringof") {

                            format = "{0}({2}," + format + ")";

                        } else {

                            format = "{0}(" + format + ",{2})";

                        }

                    } else {

                        format = "{2} {0} " + format;

                    }



                    filter = kendo.format(format, filter, value, field);

                }

            }



            result.push(filter);

        }



        filter = result.join(" " + logic + " ");



        if (result.length > 1) {

            filter = "(" + filter + ")";

        }



        return filter;

    }



    extend(true, kendo.data, {

        schemas: {

            odataCors: {

                type: "json",

                data: "d.results",

                total: "d.__count"

            }

        },

        transports: {

            odataCors: {

                read: {

                    cache: true, // to prevent jQuery from adding cache buster

                    dataType: "json",

                },
                
                update: {
                	type: "POST", 
                	
                	dataType: "json",
                	
                	data: "", 
                	
                	contentType: "application/json", 
                	
                	beforeSend: function(xhr, s) { s.data = JSON.stringify($.parseQueryString(s.data)); }
                },

                parameterMap: function(options, type) {
                    type = type || "read";

                    var params = {},

                        option,

                        dataType = (this.options || defaultDataType)[type].dataType;

                    options = options || {};

					var mapper = mappers[type] || {};
                    for (option in options) {
                    	if(undefined == option || "undefined" == option) continue;
                    	
                        if (mapper[option]) {
							if("function" == typeof mapper[option]) {
                            	mapper[option](params, options[option]);
                            }
                            else {
                            	params[option] = mapper[option];
                            }

                        } else {
                            params[option] = options[option];

                        }

                    }

                    return params;

                }

            }

        }

    });

})(jQuery);

